tabloc = {
	locked : {},
	isLocked : function(tabId) {
		return tabloc.locked["locked_" + tabId];
	},
	setLocked : function(tabId, value) {
		if(value){
			tabloc.locked["locked_" + tabId] = value;
		}else{
			delete tabloc.locked["locked_" + tabId];
		}
	},
	getOptions : function() {
		return {
			fg_foreground: tabloc_options.get("fg_foreground"),
			ex_inpagelink: tabloc_options.get("ex_inpagelink"),
			ex_javascript: tabloc_options.get("ex_javascript"),
			ex_formsubmit: tabloc_options.get("ex_formsubmit"),
		};
	}
};

chrome.browserAction.onClicked.addListener(function(tab){
	if(! tabloc.isLocked(tab.id)){
		var request = tabloc.getOptions();
		request.command = "lockTab";
		chrome.tabs.sendRequest(tab.id, request, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tab.id, true);
				chrome.browserAction.setIcon({
					path: (request.fg_foreground ? "locked2.png" : "locked.png"),
					tabId: tab.id
				});
			}
		});
	}else{
		chrome.tabs.sendRequest(tab.id, {command: "unlockTab"}, function(response){
			if(response.result == "ok"){
				tabloc.setLocked(tab.id, false);
				chrome.browserAction.setIcon({
					path: "tabloc.png",
					tabId: tab.id
				});
			}
		});
	}
});

chrome.extension.onRequest.addListener(
	function(request, sender, sendResponse) {
		if (request.command == "createTab") {
			if(tabloc_options.get("pos_relative")){
				chrome.tabs.getSelected(null, function(tab){
					chrome.tabs.create({
						url: request.url,
						selected: request.selected,
						index: tab.index + 1
					});
				});
			}else{
				chrome.tabs.create({
					url: request.url,
					selected: request.selected
				});
			}
			sendResponse({result: "ok"});
		}else{
			sendResponse({});
		}
	}
);
